Merge pull request #1 from RoiKlevansky/build-using-dockerfile

Automate building using docker
This commit is contained in:
Guy Shimko 2024-10-29 22:27:10 +02:00 committed by GitHub
commit fdc2d2e4ea
No known key found for this signature in database
GPG Key ID: B5690EEEBB952194
9 changed files with 860 additions and 0 deletions

3
.gitignore vendored
View File

@ -1,3 +1,6 @@
# IDE Folders
.idea/
.vscode/
# Build folders
build/

20
Dockerfile Normal file
View File

@ -0,0 +1,20 @@
FROM ubuntu:24.04
# Install dependencies
RUN apt update && apt install -y \
g++ \
g++-aarch64-linux-gnu \
g++-arm-linux-gnueabi \
g++-powerpc-linux-gnu \
gcc \
gcc-aarch64-linux-gnu \
gcc-arm-linux-gnueabi \
gcc-powerpc-linux-gnu \
m4 \
make \
patch \
texinfo \
wget \
xz-utils
WORKDIR /app/gdb

54
Makefile Normal file
View File

@ -0,0 +1,54 @@
ARCHS := x86_64 arm aarch64 powerpc
TARGETS := $(addprefix build-, $(ARCHS))
.PHONY: clean help download_packages build patch-gdb build-docker-image $(TARGETS)
help:
@echo "Usage:"
@echo " make build"
@echo ""
@for target in $(TARGETS); do \
echo " $$target"; \
done
@echo ""
@echo " make clean"
build/build-docker-image.stamp: Dockerfile
mkdir -p build
docker build -t gdb-static .
touch build/build-docker-image.stamp
build-docker-image: build/build-docker-image.stamp
build/download-packages.stamp: build/build-docker-image.stamp src/download_packages.sh
mkdir -p build/packages
docker run --user $(shell id -u):$(shell id -g) \
--rm --volume .:/app/gdb gdb-static env TERM=xterm-256color \
/app/gdb/src/download_packages.sh /app/gdb/build/packages
touch build/download-packages.stamp
download-packages: build/download-packages.stamp
build/patch-gdb.stamp: build/build-docker-image.stamp src/gdb_static.patch build/download-packages.stamp
docker run --user $(shell id -u):$(shell id -g) \
--rm --volume .:/app/gdb gdb-static env TERM=xterm-256color \
/app/gdb/src/patch_gdb.sh /app/gdb/build/packages/gdb /app/gdb/src/gdb_static.patch
touch build/patch-gdb.stamp
patch-gdb: build/patch-gdb.stamp
build: $(TARGETS)
$(TARGETS): build-%: download-packages patch-gdb build-docker-image
mkdir -p build
docker run --user $(shell id -u):$(shell id -g) \
--rm --volume .:/app/gdb gdb-static env TERM=xterm-256color \
/app/gdb/src/build.sh $* /app/gdb/build/ /app/gdb/src/gdb_static.patch
clean:
rm -rf build
# Kill and remove all containers of image gdb-static
docker ps -a | grep -P "^[a-f0-9]+\s+gdb-static\s+" | awk '{print $$1}' | xargs docker rm -f 2>/dev/null || true
docker rmi -f gdb-static 2>/dev/null || true

View File

@ -2,6 +2,53 @@
The statically compiled gdb / gdbserver binaries are avaliable to download under github releases!
# Compiling gdb using docker
This repository contains a dockerfile and build scripts to compile gdb and gdbserver statically for multiple architectures.
Currently, the supported architectures are:
- x86_64
- arm
- aarch64
- powerpc (32bit)
You can easily expand it to support more architectures by adding the appropriate cross compilers to the dockerfile, and other build scripts.
NOTE: You don't need to interact with the dockerfile directly, as the Makefile will take care of everything for you.
## Building for a specific architecture
To build for a specific architecture, you can use the following command:
```bash
make build-<ARCH>
```
For example, to build for arm:
```bash
make build-arm
```
The resulting binaries will be placed under the `build/artifacts/` directory.
Each architecture will have its own directory under `build/artifacts/`. For example, the arm architecture will have the following directory structure:
```
build/
artifacts/
arm/
...
```
## Building for all architectures
To build for all architectures, you can use the following command:
```bash
make build
```
## Cleaning the build
To clean the build, you can use the following command:
```bash
make clean
```
# Notes about this file - read before proceeding!
While i already provided the gdb/gdbserver-15 statically compiled binaries handed out to you, some people might want to compile it to a different architecture, or compile a newer version of gdb in the future :). This rest of the file contains my compilation documentation so that you could save yourself some time and do it yourself, if you wish.
@ -86,6 +133,8 @@ II) run `../configure CC=<CROSS_COMPILER_C> CXX=<CROSS_COMPILER_CPP> --enable-st
III) run `make -j$(nproc)`
IV) run `mkdir ./src/.libs/lib`
V) run `cp ./src/.libs/libmpfr.a ./src/.libs/lib`
VI) run `mkdir ./src/.libs/include`
VII) run `cp ../src/mpfr.h ./src/.libs/include/`
## 4) Compiling gdb

388
src/build.sh Executable file
View File

@ -0,0 +1,388 @@
#!/bin/bash
# Include utils library
script_dir=$(dirname "$0")
. "$script_dir/utils.sh"
function set_compliation_variables() {
# Set compilation variables such as which compiler to use.
#
# Parameters:
# $1: target architecture
#
# Returns:
# 0: success
# 1: failure
supported_archs=("arm" "aarch64" "powerpc" "x86_64")
local target_arch="$1"
if [[ ! " ${supported_archs[@]} " =~ " ${target_arch} " ]]; then
>&2 echo "Error: unsupported target architecture: $target_arch"
return 1
fi
>&2 fancy_title "Setting compilation variables for $target_arch"
if [[ "$target_arch" == "arm" ]]; then
CROSS=arm-linux-gnueabi-
export HOST=arm-linux-gnueabi
elif [[ "$target_arch" == "aarch64" ]]; then
CROSS=aarch64-linux-gnu-
export HOST=aarch64-linux-gnu
elif [[ "$target_arch" == "powerpc" ]]; then
CROSS=powerpc-linux-gnu-
export HOST=powerpc-linux-gnu
elif [[ "$target_arch" == "x86_64" ]]; then
CROSS=""
export HOST=x86_64-linux-gnu
fi
export CC="${CROSS}gcc"
export CXX="${CROSS}g++"
export CFLAGS="-O2"
export CXXFLAGS="-O2"
}
function build_iconv() {
# Build libiconv.
#
# Parameters:
# $1: iconv package directory
# $2: target architecture
#
# Echoes:
# The libiconv build directory
#
# Returns:
# 0: success
# 1: failure
local iconv_dir="$1"
local target_arch="$2"
local iconv_build_dir="$(realpath "$iconv_dir/build-$target_arch")"
echo "$iconv_build_dir"
mkdir -p "$iconv_build_dir"
if [[ -f "$iconv_build_dir/lib/.libs/libiconv.a" ]]; then
>&2 echo "Skipping build: iconv already built for $target_arch"
return 0
fi
pushd "$iconv_build_dir" > /dev/null
>&2 fancy_title "Building libiconv for $target_arch"
../configure --enable-static "CC=$CC" "CXX=$CXX" "--host=$HOST" \
"CFLAGS=$CFLAGS" "CXXFLAGS=$CXXFLAGS" 1>&2
if [[ $? -ne 0 ]]; then
return 1
fi
make -j$(nproc) 1>&2
if [[ $? -ne 0 ]]; then
return 1
fi
cp -r ./include ./lib/.libs/
mkdir -p ./lib/.libs/lib/
cp ./lib/.libs/libiconv.a ./lib/.libs/lib/
>&2 fancy_title "Finished building libiconv for $target_arch"
popd > /dev/null
}
function build_libgmp() {
# Build libgmp.
#
# Parameters:
# $1: libgmp package directory
# $2: target architecture
#
# Echoes:
# The libgmp build directory
#
# Returns:
# 0: success
# 1: failure
local gmp_dir="$1"
local target_arch="$2"
local gmp_build_dir="$(realpath "$gmp_dir/build-$target_arch")"
echo "$gmp_build_dir"
mkdir -p "$gmp_build_dir"
if [[ -f "$gmp_build_dir/.libs/lib/libgmp.a" ]]; then
>&2 echo "Skipping build: libgmp already built for $target_arch"
return 0
fi
pushd "$gmp_build_dir" > /dev/null
>&2 fancy_title "Building libgmp for $target_arch"
../configure --enable-static "CC=$CC" "CXX=$CXX" "--host=$HOST" \
"CFLAGS=$CFLAGS" "CXXFLAGS=$CXXFLAGS" 1>&2
if [[ $? -ne 0 ]]; then
return 1
fi
make -j$(nproc) 1>&2
if [[ $? -ne 0 ]]; then
return 1
fi
mkdir -p ./.libs/include/
cp gmp.h ./.libs/include/
mkdir -p ./.libs/lib/
cp ./.libs/libgmp.a ./.libs/lib/
>&2 fancy_title "Finished building libgmp for $target_arch"
popd > /dev/null
}
function build_libmpfr() {
# Build libmpfr.
#
# Parameters:
# $1: mpfr package directory
# $2: libgmp build directory
# $3: target architecture
#
# Echoes:
# The libmpfr build directory
#
# Returns:
# 0: success
# 1: failure
local mpfr_dir="$1"
local libgmp_build_dir="$2"
local target_arch="$3"
local mpfr_build_dir="$(realpath "$mpfr_dir/build-$target_arch")"
mkdir -p "$mpfr_build_dir"
echo "$mpfr_build_dir"
if [[ -f "$mpfr_build_dir/src/.libs/lib/libmpfr.a" ]]; then
>&2 echo "Skipping build: libmpfr already built for $target_arch"
return 0
fi
pushd "$mpfr_dir/build-$target_arch" > /dev/null
>&2 fancy_title "Building libmpfr for $target_arch"
../configure --enable-static "--with-gmp-build=$libgmp_build_dir" \
"CC=$CC" "CXX=$CXX" "--host=$HOST" \
"CFLAGS=$CFLAGS" "CXXFLAGS=$CXXFLAGS" 1>&2
if [[ $? -ne 0 ]]; then
return 1
fi
make -j$(nproc) 1>&2
if [[ $? -ne 0 ]]; then
return 1
fi
mkdir -p ./src/.libs/include
cp ../src/mpfr.h ./src/.libs/include/
mkdir -p ./src/.libs/lib
cp ./src/.libs/libmpfr.a ./src/.libs/lib/
>&2 fancy_title "Finished building libmpfr for $target_arch"
popd > /dev/null
}
function build_gdb() {
# Configure and build gdb.
#
# Parameters:
# $1: gdb directory
# $2: target architecture
# $3: libiconv prefix
# $4: libgmp prefix
# $5: libmpfr prefix
#
# Echoes:
# The gdb build directory
#
# Returns:
# 0: success
# 1: failure
local gdb_dir="$1"
local target_arch="$2"
local libiconv_prefix="$3"
local libgmp_prefix="$4"
local libmpfr_prefix="$5"
local gdb_build_dir="$(realpath "$gdb_dir/build-$target_arch")"
echo "$gdb_build_dir"
mkdir -p "$gdb_build_dir"
if [[ -f "$gdb_build_dir/gdb/gdb" ]]; then
>&2 echo "Skipping build: gdb already built for $target_arch"
return 0
fi
pushd "$gdb_build_dir" > /dev/null
>&2 fancy_title "Building gdb for $target_arch"
../configure --enable-static --with-static-standard-libraries --disable-tui --disable-inprocess-agent \
"--with-libiconv-prefix=$libiconv_prefix" --with-libiconv-type=static \
"--with-gmp=$libgmp_prefix" \
"--with-mpfr=$libmpfr_prefix" \
"CC=$CC" "CXX=$CXX" "--host=$HOST" \
"CFLAGS=$CFLAGS" "CXXFLAGS=$CXXFLAGS" 1>&2
if [[ $? -ne 0 ]]; then
return 1
fi
make -j$(nproc) 1>&2
if [[ $? -ne 0 ]]; then
return 1
fi
>&2 fancy_title "Finished building gdb for $target_arch"
popd > /dev/null
}
function install_gdb() {
# Install gdb binaries to an artifacts directory.
#
# Parameters:
# $1: gdb build directory
# $2: artifacts directory
# $3: target architecture
#
# Returns:
# 0: success
# 1: failure
local gdb_build_dir="$1"
local artifacts_dir="$2"
local target_arch="$3"
if [[ -d "$artifacts_dir/$target_arch" && -n "$(ls -A "$artifacts_dir/$target_arch")" ]]; then
>&2 echo "Skipping install: gdb already installed for $target_arch"
return 0
fi
temp_artifacts_dir="$(mktemp -d)"
mkdir -p "$artifacts_dir/$target_arch"
make -C "$gdb_build_dir" install "DESTDIR=$temp_artifacts_dir" 1>&2
if [[ $? -ne 0 ]]; then
rm -rf "$temp_artifacts_dir"
return 1
fi
while read file; do
cp "$file" "$artifacts_dir/$target_arch/"
done < <(find "$temp_artifacts_dir/usr/local/bin" -type f -executable)
rm -rf "$temp_artifacts_dir"
}
function build_and_install_gdb() {
# Build gdb and install it to an artifacts directory.
#
# Parameters:
# $1: gdb package directory
# $2: libiconv prefix
# $3: libgmp prefix
# $4: libmpfr prefix
# $5: install directory
# $6: target architecture
#
# Returns:
# 0: success
# 1: failure
local gdb_dir="$1"
local libiconv_prefix="$2"
local libgmp_prefix="$3"
local libmpfr_prefix="$4"
local artifacts_dir="$5"
local target_arch="$6"
gdb_build_dir="$(build_gdb "$gdb_dir" "$target_arch" "$libiconv_prefix" "$libgmp_prefix" "$libmpfr_prefix")"
if [[ $? -ne 0 ]]; then
return 1
fi
install_gdb "$gdb_build_dir" "$artifacts_dir" "$target_arch"
if [[ $? -ne 0 ]]; then
return 1
fi
}
function build_gdb_with_dependencies() {
# Build gdb for a specific target architecture.
#
# Parameters:
# $1: target architecture
# $2: build directory
local target_arch="$1"
local build_dir="$2"
local packages_dir="$build_dir/packages"
local artifacts_dir="$build_dir/artifacts"
set_compliation_variables "$target_arch"
if [[ $? -ne 0 ]]; then
return 1
fi
mkdir -p "$packages_dir"
iconv_build_dir="$(build_iconv "$packages_dir/libiconv" "$target_arch")"
if [[ $? -ne 0 ]]; then
return 1
fi
gmp_build_dir="$(build_libgmp "$packages_dir/gmp" "$target_arch")"
if [[ $? -ne 0 ]]; then
return 1
fi
mpfr_build_dir="$(build_libmpfr "$packages_dir/mpfr" "$gmp_build_dir" "$target_arch")"
if [[ $? -ne 0 ]]; then
return 1
fi
build_and_install_gdb "$packages_dir/gdb" \
"$iconv_build_dir/lib/.libs/" \
"$gmp_build_dir/.libs/" \
"$mpfr_build_dir/src/.libs/" \
"$artifacts_dir" \
"$target_arch"
if [[ $? -ne 0 ]]; then
return 1
fi
}
function main() {
if [[ $# -ne 3 ]]; then
>&2 echo "Usage: $0 <target_arch> <build_dir>"
exit 1
fi
build_gdb_with_dependencies "$1" "$2"
if [[ $? -ne 0 ]]; then
>&2 echo "Error: failed to build gdb with dependencies"
exit 1
fi
}
main "$@"

222
src/download_packages.sh Executable file
View File

@ -0,0 +1,222 @@
#!/bin/bash
# Include utils library
script_dir=$(dirname "$0")
. "$script_dir/utils.sh"
# List of package URLs to download
PACKAGE_URLS=(
"https://ftp.gnu.org/pub/gnu/libiconv/libiconv-1.17.tar.gz"
"https://gmplib.org/download/gmp/gmp-6.3.0.tar.xz"
"https://www.mpfr.org/mpfr-current/mpfr-4.2.1.tar.xz"
"https://ftp.gnu.org/gnu/gdb/gdb-15.1.tar.xz"
)
function unpack_tarball() {
# Unpack a tarball based on its extension.
# Supported extensions: tar, gz, xz.
#
# Parameters:
# $1: tarball
#
# Returns:
# 0: success
# 1: failure
local tarball="$1"
local extension="${tarball##*.}"
if [[ ! -f "$tarball" ]]; then
>&2 echo "Error: $tarball does not exist"
return 1
fi
case "$extension" in
tar | xz)
tar xf "$tarball"
;;
gz)
tar xzf "$tarball"
;;
*)
>&2 echo "Error: unknown extension $extension"
return 1
;;
esac
if [[ $? -ne 0 ]]; then
>&2 echo "Error: failed to unpack $tarball"
return 1
fi
}
function download_package() {
# Download a package. Will skip download if the output file already exists.
#
# Parameters:
# $1: URL of the package
# $2: output file
#
# Returns:
# 0: success
# 1: failure
local url="$1"
local output="$2"
if [[ -f "$output" ]]; then
>&2 echo "Skipping download: $output already exists"
return 0
fi
wget "$url" -O "$output"
if [[ $? -ne 0 ]]; then
>&2 echo "Error: failed to download $url"
return 1
fi
}
function extract_package() {
# Extract a package. Will skip extraction if the package directory already exists.
#
# Parameters:
# $1: package tarball
# $2: output directory
#
# Returns:
# 0: success
# 1: failure
local tarball="$1"
local output_dir="$2"
local package_dir="${tarball%.tar*}"
local tarball_realpath="$(realpath "$tarball")"
local temp_dir="$(mktemp -d)"
if [[ ! -f "$tarball" ]]; then
>&2 echo "Error: $tarball does not exist"
return 1
fi
if [[ -d "$output_dir" ]]; then
>&2 echo "Skipping extraction: $output_dir already exists"
return 0
fi
pushd "$temp_dir" > /dev/null
unpack_tarball "$tarball_realpath"
if [[ $? -ne 0 ]]; then
popd > /dev/null
return 1
fi
popd > /dev/null
mv "$temp_dir/$package_dir" "$output_dir"
if [[ $? -ne 0 ]]; then
return 1
fi
rm -rf "$temp_dir"
}
function download_and_extract_package() {
# Download and extract a package.
#
# Parameters:
# $1: URL of the package
# $2: output directory
#
# Returns:
# 0: success
# 1: failure
local url="$1"
local output_dir="$2"
local tarball=$(basename "$url")
download_package "$url" "$tarball"
if [[ $? -ne 0 ]]; then
return 1
fi
extract_package "$tarball" "$output_dir"
if [[ $? -ne 0 ]]; then
return 1
fi
}
function package_url_to_dir() {
# Convert a package URL to a directory name.
#
# Parameters:
# $1: package URL
#
# Echoes:
# The package directory name
#
# Returns:
# 0: success
# 1: failure
local url="$1"
# The name of the package is the basename of the URL without the version number.
local package_dir=$(basename "$url")
package_dir="${package_dir%%-*}"
echo "$package_dir"
}
function download_gdb_packages() {
# Download and extract all required packages for building GDB.
#
# Parameters:
# $1: packages directory
#
# Returns:
# 0: success
# 1: failure
local packages_dir="$1"
pushd "$packages_dir"
# Run downloads in parallel
download_pids=()
fancy_title "Starting download of GDB packages"
for url in "${PACKAGE_URLS[@]}"; do
package_dir=$(package_url_to_dir "$url")
download_and_extract_package "$url" "$package_dir" &
download_pids+=($!)
done
for pid in "${download_pids[@]}"; do
wait "$pid"
if [[ $? -ne 0 ]]; then
popd
return 1
fi
done
fancy_title "Finished downloading GDB packages"
popd
}
function main() {
if [[ $# -ne 1 ]]; then
>&2 echo "Usage: $0 <packages_dir>"
exit 1
fi
download_gdb_packages "$1"
if [[ $? -ne 0 ]]; then
>&2 echo "Error: failed to download GDB packages"
exit 1
fi
}
main "$@"

57
src/patch_gdb.sh Executable file
View File

@ -0,0 +1,57 @@
#!/bin/bash
# Include utils library
script_dir=$(dirname "$0")
. "$script_dir/utils.sh"
function apply_patch() {
# Apply a patch to a directory.
#
# Parameters:
# $1: directory
# $2: path of patch
#
# Returns:
# 0: success
# 1: failure
local dir="$1"
local patch="$(realpath "$2")"
pushd "$dir" > /dev/null
if [[ $? -ne 0 ]]; then
return 1
fi
# Check if the patch was already applied
if ! patch -p1 --dry-run < "$patch" &>/dev/null; then
>&2 echo "Error: patch already applied"
popd > /dev/null
return 1
fi
patch -p1 < "$patch"
if [[ $? -ne 0 ]]; then
popd > /dev/null
return 1
fi
popd > /dev/null
}
function main() {
if [[ $# -ne 2 ]]; then
>&2 echo "Usage: $0 <gdb_dir> <gdb_patch>"
exit 1
fi
fancy_title "Applying GDB patch"
apply_patch "$1" "$2"
if [[ $? -ne 0 ]]; then
>&2 echo "Error: failed to apply GDB patch"
exit 1
fi
fancy_title "Finished applying GDB patch"
}
main "$@"

67
src/utils.sh Executable file
View File

@ -0,0 +1,67 @@
#!/bin/bash
GREEN="\033[0;32m"
BOLD="\033[1m"
RESET="\033[0m"
function print_centered() {
# Print a string centered in the terminal.
#
# Parameters:
# $1: string
# $2: line width
#
# Returns:
# 0: success
local string="$1"
local length=${#string}
printf "%*s\n" $((($2 + length) / 2)) "$string"
}
function fancy_title() {
# Print a fancy title.
# The title is centered and surrounded by a line of dashes.
#
# Parameters:
# $1: title
#
# Returns:
# 0: success
local title="$1"
local length=80
local maximum_title_length=60
# Set color to green and bold
tput setaf 2
tput bold
printf "%${length}s\n" | tr ' ' -
# Split the title into words and print them centered
IFS=' ' read -r -a words <<< "$title"
line=""
for word in "${words[@]}"; do
if [[ ${#line} -eq 0 ]]; then
line="$word"
elif [[ $(( ${#line} + ${#word} + 1 )) -gt $maximum_title_length ]]; then
print_centered "$line" "$length"
line="$word"
else
line="$line $word"
fi
done
# Print the last line
if [[ ${#line} -gt 0 ]]; then
print_centered "$line" "$length"
fi
printf "%${length}s\n" | tr ' ' -
# Reset color and style
tput sgr0
}